/* This file is part of Om.  Copyright (C) 2005 Dave Robillard.
 * 
 * Om is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * Om is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef SETMETADATAEVENT_H
#define SETMETADATAEVENT_H

#include <string>
#include "SlowEvent.h"

using std::string;

namespace Om {

class OmObject;


/** An event to set a piece of metadata for an OmObject.
 *
 * \ingroup engine
 */
class SetMetadataEvent : public SlowEvent
{
public:
	SetMetadataEvent(Request* request, const string& path, const string& key, const string& value);
	
	void prepare();
	void execute(uint sample_offset);
	void post_process();

private:
	string    m_path;
	string    m_key;
	string    m_value;
	OmObject* m_object;
};


} // namespace Om

#endif // SETMETADATAEVENT_H
